/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Semaphore.h,v 1.15 2003/08/26 19:50:16 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_LANG_SEMAPHORE_H
# define INCLUDE_JAKELIB2_LANG_SEMAPHORE_H

# ifdef HAVE_SEMAPHORE_H
#  include <semaphore.h>
# endif
# if defined(JAKELIB_WIN32API)
#  include <windows.h>
# endif

namespace jakelib {
  namespace lang {

    /**
     * @class Semaphore
     * @version $Id: Semaphore.h,v 1.15 2003/08/26 19:50:16 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class Semaphore : public Object
      {
      public:
	Semaphore();
	Semaphore(int startCount);

	JAKELIB_DECLARE_CLASS(Semaphore);

	~Semaphore();
	void wait(long millis);
	void wait();
	void notify();
	void v();
	void p();
  
      protected:
#if defined(JAKELIB_WIN32API)
	HANDLE handle;
#elif defined(HAVE_PTHREADS)
	sem_t sema;
#endif

	void init(int start);
      };

  }
}

#endif

